#include <iostream>
#include <stdlib.h>

using namespace std;

int cases;

typedef struct pline
{
  char jed[11];
  long cnt;
  char jed2[11];
};

typedef struct wzorzec
{ 
  long val;
  char orgm[11];
  double legval;
};

wzorzec wzo[100001];
pline inlns[4];

char cnn[4][11];
int cnnfull;

int cnts[4];

int counters;
long numwz,lzap;

double prze[4][4];

void addtotbl(char * j);
int getindex(char * j);

int main()
{
  cin>>cases;

  char nlx[10];
  for (int a=0; a<cases; a++)
  {
    cin>>counters;
    int b;

    for (b=0; b<counters; b++)
    {
      cin>>nlx>>inlns[b].jed;
      cin>>nlx>>inlns[b].cnt>>inlns[b].jed2;
    }
    cnnfull = 0;
    for (b=0; b<counters; b++)
    {
      addtotbl(inlns[b].jed);
      addtotbl(inlns[b].jed2);
    }
//    for (b=0; b<cnnfull; b++)
  //   cout<<cnn[b]<<endl;

    for (b=0; b<4; b++)
      for (int fgh=0; fgh<4; fgh++)
      {
        prze[b][fgh] = 0;
        if (b == fgh) prze[b][fgh] = 1;
      } 

    for (b=0;b<counters; b++)
    {
      int ind1 = getindex(inlns[b].jed);
      int ind2 = getindex(inlns[b].jed2);
      prze[ind1][ind2] = (double) inlns[b].cnt;
      prze[ind2][ind1] = 1.0/(double) inlns[b].cnt;
     
    }
    int chg = 1;
    while(chg)
    {
      chg = 0;
      for (b=0; b<cnnfull; b++)
        for (int c=0; c<cnnfull; c++)
          for (int d=0; d<cnnfull; d++)
            if (prze[b][c] == 0)
            {
              prze[b][c] = prze[b][d] * prze[d][c];
              chg = 1;
            } 
              
      
    }

    cin>>numwz;
    for (b=0; b<numwz; b++)
    {
      cin>>wzo[b].val>>wzo[b].orgm;
      int ind = getindex(wzo[b].orgm);
      wzo[b].legval = (double) wzo[b].val*prze[ind][0];
    }

    
    
  //  for (b=0; b<numwz; b++)
     // for (int c=0; c<cnnfull; c++)
     //   cout<<"B: "<<b<<" C: "<<c<<" pr "<<prze[b][c]<<endl;
//     cout<<"B: "<<b<<" val "<<wzo[b].val<<" jed "<<wzo[b].orgm<<" lval "<<wzo[b].legval<<endl;
    long numzap;
    cin>>numzap;
    char jedp[11];
    long ilp;
    long bestw;
    double bestval, bestdiff;

    for (b=0; b<numzap; b++)
    {
      cin>>ilp>>jedp;
      int index = getindex(jedp);
      double lval = (double) ilp * prze[index][0];

      bestw = 0;
      bestval = -1;
      bestdiff = 999999999;

      for (int d = 0; d<numwz; d++)
      {
        double diff = lval - wzo[d].legval;
        if (diff<0) diff = - diff;
  
//      cout<<"lval "<<lval<< " wzo "<<wzodiff;
  
        if ((diff<bestdiff) || ((diff == bestdiff) && (wzo[d].legval<bestval)))
        {
          bestw = d;
          bestval = wzo[d].legval;
          bestdiff = diff;
        }
      } 
      cout<<wzo[bestw].val<<" "<<wzo[bestw].orgm<<endl;
      
    }
  }  
  return 0;
}

void addtotbl(char *j)
{
 // cout<<endl<<j;
  for (int a=0; a<cnnfull; a++)
    if (!strcmp(j,cnn[a]))
      return;
//  cout<<"ok"<<endl;  

  strcpy(cnn[cnnfull++],j);
  return;
}

int getindex(char * j)
{
  for (int a=0; a<cnnfull; a++)
    if (!strcmp(j,cnn[a]))
      return a;
  return 0;
}
